/* Jeff Connelly
 * C4 L1 
 * Taxes
 */

#include <iostream.h>
#include <stdlib.h>
#include <iomanip.h>

// Taxes
const double TAX_FEDERAL = 0.150;
const double TAX_FICA    = 0.080;
const double TAX_STATE   = 0.032;

double calc_gross(double hours, double rate);
double calc_net(double gross, double tax);

int main()
{
	double hours, rate, gross, net;
	char again;

	// Loop until user can't take it anymore
	do
	{
		// Receive hours worked and hourly rate
		cout << endl << endl << "Hours worked: ";
		cin >> hours;
		cout << "Hourly rate: ";
		cin >> rate;

		// Output two fixed decimal points
		cout.setf(ios::fixed);
		cout << setprecision(2);

		// Calculate gross and net income from rate and taxes
		gross = calc_gross(hours, rate);
		net   = calc_net  (gross, TAX_FEDERAL + TAX_FICA + TAX_STATE);

		// Output calculated calculations
		cout << endl
			<< "Hours worked:  " << hours << endl
			<< "Hourly rate:  $" << rate  << endl
			<< "Gross pay:    $" << gross << endl
			<< "Net pay:      $" << net   << endl
			<< flush;

		// If these values entered, make sure the outputs are correct. Test with:
		// Hours worked     30
		// Hourly rate      12.37
		// Gross pay        371.10
		// Net pay          273.86
		(hours == 30 && rate == 12.37) && 
			(
				cout << endl << "example test: " &&
				(
					((int)gross == 371 && (int)net == 273)   // only an estimate 
					&&
							cout << "pass"
						||
							cout << "fail"
				)
				&&
				cout << endl << flush
			);
		
		cout << "Run again (y)? ";
		cin  >> again;
		
		again &= ~32;  // Caselessify "again", accept ASCII 'Y' and 'y'

	} while (again == 'Y');

	system("pause");
	return 0;
}

// Calculate gross income from hours and $/hr
double calc_gross(double hours, double rate)
{
	return rate * hours;
}

// Calculate net pay from gross income and total tax amount
double calc_net(double gross, double tax)
{
	return gross - gross * tax;
}


