/* Jeff Connelly
 * C5 L3
 * apvector, apstring, and conditional loops part II
 */

#include <apstring.h>
#include <apvector.h>
#include <iostream.h>
#include <stdlib.h>


// Structure (not yet class) which overloads << and >> to allow easy input/output
typedef struct tagPLAYER
{
	apstring name;
	double ba;
} PLAYER;

double team_avg(apvector<PLAYER>& v);
ostream& operator<<(ostream& os, const apvector<PLAYER>& s);
istream& operator>>(istream& is, apvector<PLAYER>& s);

int main()
{
	apvector<PLAYER> players;
	char runagain;

	do
	{
		// Get players, print players using overloaded operators
		cin >> players;
		cout << players;
		// ^ Output formatted table of players

		cout << "\nTeam Average: \t" << team_avg(players) << endl << endl;

		cout << "Add more? ('n' to quit) ";
		cin >> runagain;
		cin.ignore(80, '\n');

		cout << endl << endl;

	} while(runagain - 'n');

	return 0;
}

double team_avg(apvector<PLAYER>& v)
{
	int count;
	double sum;

	for(int i = 0; i < (count=v.length()); i++)
		sum += v[i].ba;

	return sum / count;
}

// overloaded for output
// Common usage: cout << player;
ostream& operator<<(ostream& os, const apvector<PLAYER>& s)
{
	for (int i = 0; i < s.length(); i++)
		os << i << "\t" << s[i].name << "\t" << s[i].ba << endl;
	return os;
}

// overload for input, get as many players as desired
// Common usage: cin >> player
istream& operator>>(istream& is, apvector<PLAYER>& s)
{
	do
	{
		apstring line;

		cout << "Enter player: ";
		
		s.resize(s.length() + 1);
		getline(is, s[s.length() - 1].name);

		if (!(s[s.length() - 1].name.length()))
		{
			s.resize(s.length() - 1);
			break;
		}

		cout << "Enter " << s[s.length() - 1].name << "'s batting average: ";
		getline(is, line);
		
		s[s.length() - 1].ba = atof((const char*)line.c_str());

		if (!(line.length()))
			break;

	} while (1);

	return is;
}

