/* Jeff Connelly
 * C6 L1 IRS, declaration header include file
 * 27Sep 02
 */

// IRS filing status, for taxing purposes
enum FILING_STATUS { UNDEFINED, SINGLE, MARRIED };

// Exception thrown in exceptional IRS conditions
class IRSTaxingException
{
public:
	IRSTaxingException(apstring);
	IRSTaxingException(int);
	apstring Reason();
	int Quit();

protected:
	apstring m_reason;
	int m_quit;
};

// An IRS tax-payer class for calculating federal tax
class TaxPayer
{
public:
	TaxPayer();
	TaxPayer(FILING_STATUS status, double income);

	apstring GetStatus();
	void SetStatus(FILING_STATUS);
	bool ValidStatus();

	double GetIncome();
	void SetIncome(double);
	double GetFedTax();
	void Undefine();

protected:
	FILING_STATUS m_status;
	double m_income;
};

// Overloaded [oi]stream functions for << and >> on streams
ostream& operator<<(ostream& os, TaxPayer& citizen);
istream& operator>>(istream& is, TaxPayer& citizen);