/* Jeff Connelly
 * C6 L1 - IRS
 * 26 Sep 02
 */

/* ADD THESE FOLLOWS TO YOUR PROJECT BEFORE BUILDING:
 * -> lab1.cpp
 * -> irs.cpp
 * -> apstring.cpp (its not done automatically)
 */

 /* By default, the apstring.h included with 
    #include <apstring.h> also #includes <apstring.cpp>.
	This prevents multiple files from #include'ing the
	apstring declarations in apstring.h, effectively
	disallowing ALL multi-source projects which use
	apstring in more than one source file. */
 
// Whose idea was it to include a CPP file in an H file?
// GNU CC (gcc) even blocks against this

#include <iostream.h>
#include "apstring.h"   // modified to not #include "apstring.cpp"

#include "irs.h"

int main()
{
	TaxPayer tp;
	apstring runagain; 

	// Single
	// Taxable Income = 35,125
	// Federal tax = 6,630.50
	do
	{
		try
		{
			tp.Undefine();

			// Bulk of the program is here
			cin >> tp;
			cout << endl << tp << endl;

		} catch (IRSTaxingException e) {
			cout << endl << "**** Tax Exception caught: " << e.Reason() << endl;
			if (e.Quit())
				return 0;
		}
	} while (1);

	return 0;
}

