/* Jeff Connelly 
 * Ch8 Hw Problem #5
 * Mr. Bagg's APCS 11th Grade 1st Period
 * 20Oct 2002
 */

// "Rock-Paper-Scissors", all-new trinary version!

#include <iostream.h>
#include <stdlib.h>
#include <apstring.h>
#include <time.h>

int find_winner_trinary(int p1, int p2); // 15s for 100,000,000 iterations
int find_winner_binary(int p1, int p2);  // 14s for 100,000,000 iterations

int main()
{
	char* words[4] = { "ROCK", "PAPER", "PAPER", "SCISSORS" };
	/* //benchmarks
	int start=time(0);

	for(int i = 0; i < 100000000; i++)
	{
		int p1 = rand() & 3;
		if (p1 == 2) p1 = 3;
		int p2 = rand() & 3;
		if (p2 == 2) p2 = 3;
		int ta = find_winner_binary(p1, p2);
	}
	int end=time(0);

	cout << end-start << endl;
	return 0;*/

	do 
	{
		int user = -1, a = 0, b = 0, comp, outcome;
		apstring str_user;

		do
		{
			cout << "Rock=r, Paper=p, Scissors=s, Quit=Control-C: ";
			getline(cin, str_user);
			if (str_user.length() == 0)
				continue;

			switch(str_user[0])
			{
			case 'r': user = 0; break;
			case 'p': user = 1; break;
			case 's': user = 3; break;
			default: user = -1; break; // Invalid, will repeat loop
			}
		} while (user != 0 && user != 1 && user != 3);

		cout << words[user] << "\tvs\t";

		comp = rand() & 3;

		if (comp == 2)
			comp = 3;

		cout << words[comp];
		cout << endl;

		//outcome = find_winner_trinary(user, comp);
		outcome = find_winner_trinary(user, comp);

		switch(outcome)
		{
		case 0: cout << "Computer (" << words[comp] << ") won over " << words[user] << endl; break;
		case 1: cout << "tie" << endl; break;
		case 3: cout << "Human won (" << words[user] << ") won over " << words[comp] << endl; break;
		default: cout << "/Someones/ trinary logic is borked.. *looks around*" 
	                      << outcome << endl;
		}

	} while (1);
	return 0;
} 

// The more obvious way...1=tie, 0=computer, 3=human. One sec faster than trinary, so what
int find_winner_binary(int user, int comp)
{
	// R P S
	// 0 1 3
	// 
	// 0>3
	// 1>0
	// 3>1
	if (user == comp)
		return 1; // tie
	if (user == 0) // rock
		return (comp == 1 /* paper */) ? 0 : 3 /* scissors */;
	if (user == 1) // paper
		return (comp == 2 /* rock */) ? 3 : 0 /* scissors */;
	if (user == 2) // scissors
		return (comp == 1 /* paper */) ? 3 : 0 /* rock */;
	return 1;
}


// This function implements a TRINARY (base 3) DYADIC (2-input) logic
// gate, found only on TERNACs such as Setun (circa 1958, Russia)--not
// binary computers-- to quickly calculate the result of the game
// (Runs best on trinary computers).
int find_winner_trinary(int user, int comp)
{
	int outcome, a = 0, b = 0;

	b = user & 1;
	a = (user & 2) >> 1;
	/*
	switch(user)
	{
	case 3:	a = 1;       // Notice: Falls through
	case 1: b = 1; 
	}*/

	// If you want to understand this, thoroughly read 
	// http://jeff.tk/trinary/ cover-to-cover, several times
	// deep wizardry here, you have been warned
	switch(comp)
	{
	case 0: outcome = ((a ^ b) << 1) | (!(a & b)); break;
	case 1: outcome = ((a & b) << 1) | (a | b); break;
	case 2: 
	case 3: outcome = (!(a | b) << 1) | !(a ^ b);	break;
	default: cout << "Uh??" << comp << endl; exit(42);
	}

	//return !b ? ((a ^ b) << 1) | (!(a & b)) : 
	//(a ? (!(a | b) << 1) | !(a ^ b) :  ((a & b) << 1) | (a | b));

	return outcome;
}
