/* Jeff Connelly
 * 06 Nov 2002
 * Pascal's Triangle || Simplified Version
 */

#include <iostream.h>
#include <apvector.h>
#include <apstring.h>

// Useful utility functions
apstring rep(int ch, int n); // Repeat CH, N times
apstring space(int n);       // Spacing of N characters
int digits(int n);           // Number of decimal digits in N

int main()
{
	cout << "Pascal's Triangle Calculation (^C=Quit)" << endl << endl;
	
	while(1)
	{
		apvector<int> row(2, 1);                    // 1 1
		apvector<int> last;
		int max;
		
		cout << "Iterate until row (recommended 15)# ";
		cin >> max;
		
		if (!max)
			return 0;
		max += 2;

		cout << space(80 / 2 + 1) + "1" << endl;     // Apex always 1

		for(int n = 3; n < max; n++)                 // Calculate lower portions of pyramid
		{
			int linelen = 0;                         // Line length for spacing purposes

			last = row;                              // Previous row
			row.resize(n);                           // Row N is N width

			row[0] = row[n - 1] = 1;                 // Left-Right edges
			
			for(int a = 0; a < n - 1; a++)           // Columns 0 to N-1
			{
				if (a != 0 && a != row.length() - 2) // Calculate cols 1..N-1
					row[a] = last[a - 1] + last[a];  // v Account for spacing in cols 0..N
				linelen += (5 - digits(row[a])) + digits(row[a]);

			}

			cout << space((80 - linelen) / 2);       // Initial textual column position
	
			for(int i = 0; i < row.length() - 1; i++)// Output digits w/ correct spacing
			{
				cout << space(5 - digits(row[i])) << row[i];
			}
			cout << endl;
		}
	}
	return;
}

// Return the number of base 10 decimal digits in n, for printing
int digits(int n)
{
	int digits = 0;

	if (n < 0)
		digits += 1;  // Account for "-" sign

	while(n)
	{
		n /= 10;
		digits++;
	}

	return digits;
}

// Return 'n' number of spaces
apstring space(int n)
{
	return rep(' ', n);
}

// Repeat character 'ch' 'n' number of times
apstring rep(int ch, int n)
{
	apstring s;

	if (n < 0)
	{
		cout << "Negative repetition count " << n << " in rep, not enough space, bailing out." << endl;
		cout << "Hint: Try a lower maximum" << endl;
		exit(-3);
	}

	while(n--)
		s += ch;

	return s;
}

